{{

  Progue - a rogue-like written in Spin
  Copyright (C) 2007  Christopher Merck
  Contact: navaburo@gmail.com

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
   
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  Progue uses VGA and keyboard drives authored by Parallax, Inc.
   See object files for appropriate credit.

  Thanks to Mike Green and ProcessingData of the Prop Forum for 
    their contributions and playtesting :) 

  If you have any questions / comments / bug reports / bug fixes,
   or changes to the code please email them to me (navaburo@gmail.com),
   or post to the Parallax forum thread on the game:
   <http://forums.parallax.com/forums/default.aspx?f=33&m=195502>

  Enjoy,
   Chris
   
  }}

CON
   {{This program will work on the Parallax demo board or Hydra kit,
      simply set the appropriate constant}}
   Demo      = true                   ' Demo Board
   Proto     = false                  ' Proto Board
   Hydra     = false                  ' Hydra
   
   'progsize  = 8192                    ' Space reserved for program
   _clkmode  = xtal1 + ((Hydra & pll8x) | ((Demo | Proto) & pll16x))
   _xinfreq  = (Hydra & 10_000_000) | ((Demo | Proto) & 5_000_000)
   _stack    = 100                     ' Roughly 4 nested expressions
   '_free     = (progsize + dsp#rows * (dsp#cols + 2) + 12) / 4

'  dspPins   = (Hydra & 24) | ((Demo | Proto) & 12)   ' TV
   dspPins   = 16                                     ' VGA
   keyPins   = (Hydra & 13) | ((Demo | Proto) & 26)


  'terminal signals
  ClrScr = $00
  Home   = $01
  Seek   = $02 
  Bsp    = $08
  Cr     = $0D
  MoveX  = $0E
  MoveY  = $0F

  cols = 80
  rows = 40
   
OBJ

  text : "vga_Drive"          
  kb   : "comboKeyboard"

CON

  titleblock_x = cols / 2 - 25
  titleblock_y = rows / 2 - 5

  map_w = 60
  map_h = 30

  map_x_offset = 10
  map_y_offset = 4  

  {{player modifiers (states)}}
  hungry = 0
  burdened = 1
  poisoned = 2
  bleeding = 3
  confused = 4
  paralyzed = 5
  blessed = 6
  cursed = 7

  {{item states}}
  broken = 0
  heavy = 1
  strong = 2
  weak = 3
  ancient = 4
  rare = 5
  'blessed = 6
  'cursed = 7

  {{monster modifiers}}
  m_claws = 31
  m_weapon = 30 'deals more damage and may drop a weapon
  m_armor = 29 'has higher PV
  m_fast = 28 'harder to hit, and moves faster than PC
  m_angry = 27 'easier to hit, deals more damage, chance to drop blood
  m_eatable = 26 'chance to drop corpse
  m_poison = 25 'can use poison attack, corpse is poisonous
  m_fire = 24 'can use fire attack, resistant to fire, weak to ice
  m_ice = 23 'can use ice attack, resistant to ice, weak to fire
  m_undead = 22 'change to curse PC, weak to blessed weapons
  m_sentry = 21 'cannot move
  m_archer = 20 'can use missile attack, chance to drop bow/arrows
  m_breeder = 19 'occasionaly reproduces asexually (beware!)
  m_flying = 18 'harder to hit, moves sparatically, changes message
  m_weak = 17 'very few hit points (useful for regulating difficulty)
  m_confusing = 16
  m_common = 15
  m_rare = 14   'both common AND rare make for VERY rare 
  m_stone_thrower = 13 'throws rocks, may drop rocks, may drop pick axe
  m_friendly = 12 'doesnt attack unless attacked
  m_speak = 11
  m_strong = 10 'more hit points, deals (a little) more damage
  m_swap = 9 'monster can swap positions with you during combat (cannot make another move that turn)
  m_dodge = 8 'monster can sometimes dodge attacks by moving to an adjacent tile (cannot make another move that turn)
  
  'TODO add more modifiers
  'modifiers 0-7 are reserved for storing monster level
  ' this is both the first dungeon level they may be found on,
  ' and forms the basis for their hit points and damage. 
  
  'runtime monster attributes
  max_monsters = 32
  mr_active = 0  'this rid is in use
  mr_tame = 1    'does not attack PC
  mr_afraid = 2  'runs away
  mr_tapped = 3  'cannot move this turn (after swap, dodge, or being stunned)

  max_pack_items = 16
  equip_slots = 8
  {slot definitions}
  e_armor = 0   '+PV 
  e_weapon = 1  '+hit & +damage 
  e_shield = 2  '+DV
  e_boots = 3   '+speed & protection from traps
  e_amulet = 4  'magical effects
  e_bow = 5     'ranged weapon
  e_arrows = 6  'ammunition
  e_ring = 7    'magical effects

  'weapon and armor modifier flags
  wa_broken = 7   'cannot be used (unless reforged)
  wa_rusty = 6    'higher chance to break
  wa_poisoned = 5 'poisons enemy
  wa_reserved = 4

  'visible function flags
  vis_sw = 0
  vis_xn = 1
  vis_yn = 2
  vis_01 = 3
  vis_02 = 4
  vis_03 = 5
  vis_11 = 6
  vis_12 = 7
  vis_13 = 8
  vis_22 = 9

  'storyline switches
  sl_orc_is_dead = 0
  sl_longbow = 1
  sl_dark_elf_fallen = 2

  lev_orc = 5

  
VAR

  {{map data storage format:
        byte #1: display symbol (type)
        byte #2: detail byte

        TILE CLASS / FLAG: 0      1      2      3      4      5      6      7
        monster:        reserved.............................................
        potion, weapon, armor: holds index number for lookup table
        gold:           holds amount
        arrows, rocks:  holds quantity         
  }}
  word map [map_w*map_h]
  word tmp_swap

  {{monster ai memory - holds information about each active monster on the map 
        byte #1: X position
        byte #2: Y position 'TODO more can be squeezed from here as X,Y only needs 11-bits, not 16
        byte #3: flags: 0=in_use see mr_xxx
        byte #4: hp
  }}
  long monster[max_monsters]
  word under_monster[max_monsters] 'holds tile at the feet of the monster
                
  byte level 'floor of the dungeon PC is on

  byte key 'key pressed this move

  {{player properties}}
  byte p_x, op_x
  byte p_y, op_y
  long p_hp, p_hp_max
  long p_mp, p_mp_max
  long p_xp, p_level
  byte p_state
  byte p_vision
  long p_bgl 'blood glucose level (1000+ is satiated, 500- is hungry, 0 is dead)
  long p_luck      '0 is really bad luck... you DONOT want 0 luck.... really
  

  byte tmp1, tmp2

  long dice

  long dir_x
  long dir_y

  byte free_dir 'flags possible free directions
  {
        0  1  2
        3     4               
        5  6  7               
  }

  long turn_count

  long message_col
  long message_row

  long storyline 'switches to control story

  'pack items:
  byte arrows
  byte potions
  byte scrolls

  'everything required to save a game:
  byte save_potions
  byte save_arrows
  byte save_scrolls
  byte save_storyline
  byte save_level
  byte save_p_level

PUB start | i, ii, mn, mn2, rid2, rid, tmp, arrow_xs, arrow_ys, damage

  'initialize devices
  text.start(16)
  kb.start(keyPins)

  storyline := 0
        
  'display title block
  text.locate(titleblock_x,titleblock_y)
  repeat 50
    text.out("*")
  text.locate(titleblock_x,titleblock_y+1)
  text.str(string("* Progue - a rogue-like RPG written in pure Spin *"))
  text.locate(titleblock_x,titleblock_y+2)
  text.str(string("*              written by Chris Merck            *"))
  text.locate(titleblock_x,titleblock_y+3)
  text.str(string("*           Contact: navaburo@gmail.com          *"))
  text.locate(titleblock_x,titleblock_y+4)
  repeat 50
    text.out("*")
  text.locate(titleblock_x,titleblock_y+6)
  text.str(string("                      v1.0"))
  text.locate(titleblock_x-2,titleblock_y+10)
  text.str(string("NOTE: Press the <<?>> key during game to list commands. "))


  text.out(Home)                               'ensure a keyboard is present
  waitcnt(clkfreq + cnt) 'wait one second
  if not kb.present  
    text.str(string("searching for keyboard"))                
    repeat
      waitcnt(clkfreq / 1000 * 500 + cnt)
      text.out(".")
    until kb.present
    text.str(string("found!"))     
  text.locate(titleblock_x+10,rows-1)
  text.str(string("-  PRESS ANY KEY TO CONTINUE  -"))
  kb.getkey

  text.out(ClrScr) 
  text.out(Home)
  
  {*** GAME AND PC INITIALIZATION ***}
  level := 0

  p_hp_max := p_hp := 10
  p_mp_max := p_mp := 10
  p_xp := 0
  p_vision := 4
  p_luck := 128 'start with fair luck
  arrows := scrolls := potions := 0

  turn_count := 0
  repeat
    {INITIALIZE MAP}                   

    randomize_map 'this sets up the level, some of which are special 

    save_potions := potions      'restore items (so you can't farm)
    save_arrows := arrows
    save_scrolls := scrolls
    save_storyline := storyline
          
    i := 0      'initialize monster storage area
    repeat max_monsters
      monster[i] := $00000000
      under_monster[i++] := $0000

    repeat
    until kb.peekkey

    text.out(ClrScr)
    
    repeat
      key := kb.getkey 'wait for keystroke
      
      turn_count++

      'clear and reset message buffer
      message_col := 0
      message_row := 0
      text.locate(0,0)
      repeat cols*(map_y_offset-1)
        text.out(" ")

      op_x := p_x 'save PC position
      op_y := p_y

      
      {*** PARSE USER COMMAND ***}
      case key      
        'non-movement commands:
        $3F,$2F: '? (or the non-shifted version: /)
          message(string("Progue keybindings: ?=help  h=heal  e=eat  q=quaff  t=shoot  r=read  arrowkeys/numpad=walk  5=rest  >=decend"))
          next
        $65: 'e
          'TODO eat
          'seach pack for food items, how many?
          'if none, say "you own no food"
          'if one, display "you eat the ____" and increase energy level
          'if multiple, allow user to select which to eat

          'for now we just eat a corpse from the ground:
          if map[p_x+p_y*map_w] & $00FF == "%" 
            message(string("You eat the "))
            say_tile(p_x,p_y)
            map[p_x+p_y*map_w] := "." 'delete corpse
            p_hp++
            message(string(". Mmmmmm tasty! ")) 
          else
            message(string("Try standing over something eatible! "))

          p_bgl += roll(3,100) 'TODO add nurishment messages...
          'if poisoned food, make player poisoned
        $6C: 'l
          message(string("To the right of you is: "))
          say_tile(p_x+1,p_y)
        $71: 'q
          if potions == 0
            message(string("You have no potions to quaff. "))
          else
            potions--
            message(string("You drink the potion. "))
            if (p_hp < p_hp_max)
              p_hp += roll(2,6)
              if p_hp > p_hp_max
                p_hp := p_hp_max
              message(string("You feel refreshed! "))
            elseif p_mp < p_mp_max
              p_mp += roll(2,6)
              if p_mp > p_mp_max
                p_mp := p_mp_max
              message(string("You feel pious! "))
            else
              message(string("Mmmm, dwarven mead! "))
              p_luck++


        $74: 't
          'shoot an arrow
          if storyline & |<sl_longbow
            if arrows == 0
              message(string("You have no arrows. "))
            else
              arrows--
              message(string("What direction? "))
              arrow_xs := 0
              arrow_ys := 0
              repeat
                case kb.getkey                 
                  $E1,$31:
                    arrow_xs -= 1
                    arrow_ys += 1
                    tmp := "/"
                    quit
                  $E2,$32,$C3:
                    arrow_ys += 1
                    tmp := "|"
                    quit
                  $E3,$33:
                    arrow_xs += 1
                    arrow_ys += 1
                    tmp := "\"
                    quit
                  $E4,$34,$C0:
                    arrow_xs -= 1
                    tmp := "-"
                    quit
                  $E5,$35:
                    message(string("You fail to shoot yourself. "))
                    quit
                  $E6,$36,$C1:
                    arrow_xs += 1
                    tmp := "-"
                    quit
                  $E7,$37:
                    arrow_xs -= 1
                    arrow_ys -= 1
                    tmp := "\"
                    quit
                  $E8,$38,$C2:
                    arrow_ys -= 1
                    tmp := "|"
                    quit
                  $E9,$39:                                             
                    arrow_xs += 1
                    arrow_ys -= 1
                    tmp := "/"
                    quit
              if arrow_xs + 2*arrow_ys <> 0
               repeat i from 1 to 4
                text.locate(map_x_offset+p_x+i*arrow_xs,map_y_offset+p_y+i*arrow_ys)
                text.out(tmp)
                if i > 1
                  text.locate(map_x_offset+p_x+(i-1)*arrow_xs,map_y_offset+p_y+(i-1)*arrow_ys)'clean up old arrow icon
                  text.out(map[p_x+(i-1)*arrow_xs+(p_y+(i-1)*arrow_ys)*map_w]) 'this line might not be needed?
                waitcnt(clkfreq/10 + cnt) 'wait 1/3 second
                case map[p_x+i*arrow_xs+(p_y+i*arrow_ys)*map_w]
                  "y":
                    message(string("The arrow hits the gollum and breaks. "))
                    quit
                  "a".."z","A".."Z":
                    mn := map[p_x+i*arrow_xs+(p_y+i*arrow_ys)*map_w] - "a" 'gets the species of the monster
                    rid := get_monster_rid(p_x+i*arrow_xs,p_y+i*arrow_ys)'identifies instance of monster being attacked
                    pc_attacks_monster(mn,rid)
                    under_monster[rid]:="\" 'note: this is ok even if the monster was slain, because the clean-up is done later
                    quit
                  "#":
                    message(string("The arrow breaks! "))
                    quit
                if i==4
                 map[p_x+i*arrow_xs+(p_y+i*arrow_ys)*map_w]:="\"
                text.locate(map_x_offset+p_x+i*arrow_xs,map_y_offset+p_y+i*arrow_ys)'redraw tile under arrow's last position
                text.out(map[p_x+i*arrow_xs+(p_y+i*arrow_ys)*map_w])

          else
            message(string("You have no bow to shoot. "))

        $72: 'r
         'read
         if scrolls == 0
           message(string("You have nothing to read. "))
         else
           scrolls--
           message(string("You read a magic scroll. "))
           case roll(1,10)
            1:
             message(string("You are rejuvinated! "))
             p_hp := p_hp_max
             p_mp := p_mp_max
            2:
             message(string("The runes explode! "))
             p_hp -= roll(1,6)
            3..6:
             message(string("You remember things you never knew. "))
             repeat 250
               'hack: use the arrow vars as temp:
               arrow_xs := roll(1,map_w-1)
               arrow_ys := roll(1,map_h-1)
               'if get_free_dir(arrow_xs,arrow_ys) <> 0
                 text.locate(map_x_offset+arrow_xs,map_y_offset+arrow_ys)
                 text.out(map[arrow_xs+arrow_ys*map_w])
            7..9:
             message(string("Your quiver feels heavier. "))
             arrows += roll(2,6)
            9..10:
             message(string("Rats appear! "))
             repeat arrow_xs from p_x - 2 to p_x + 2
              repeat arrow_ys from p_y - 2 to p_y + 2
               if NOT (arrow_xs == p_x AND arrow_ys == p_y) AND map[arrow_xs+arrow_ys*map_w]=="."
                map[arrow_xs+arrow_ys*map_w]:="r"



        $68: 'h 
          'heal
          if p_hp < p_hp_max
            if p_mp == 0
              message(string("Your magical energies are depleated. "))
            else
              if p_mp => p_hp_max - p_hp
                p_mp -= p_hp_max - p_hp
                p_hp := p_hp_max
                message(string("You magically heal all your wounds. "))
              else
                p_hp += p_mp
                p_mp := 0
                message(string("You manage to heal some of your wounds. "))                
          else
            message(string("You have no wounds to take care of. "))


        $2E,$3E,$0D: '>   go downstairs
          if map[p_x+p_y*map_w] == ">"
            quit 'exit level loop, decending deeper!

        'movement commands  
        $E1,$31:
          p_x -= 1
          p_y += 1
        $E2,$32,$C3:
          p_y += 1
        $E3,$33:
          p_x += 1
          p_y += 1
        $E4,$34,$C0:
          p_x -= 1
        $E5,$35:
          message(string("You rest. "))
        $E6,$36,$C1:
          p_x += 1
        $E7,$37:
          p_x -= 1
          p_y -= 1
        $E8,$38,$C2:
          p_y -= 1
        $E9,$39:                                             
          p_x += 1
          p_y -= 1

      if (op_x <> p_x OR op_y <> p_y) 'check for attempted movement      
        'on-step events (cancelling move if nessisary):
        if p_state & |<paralyzed
          message(string("You can't move! "))
          p_x := op_x 'cancel move
          p_y := op_y
        
        case map[p_x+p_y*map_w] 
          "#": 'wall (non traversable, inanimate tile)
            if level==0
              message(string("You can't walk through trees! "))
            else
              message(string("Ouch! You bump into the hard stone wall. "))
            p_x := op_x 'cancel move
            p_y := op_y
          "+": 'closed door
            if level == lev_orc 'when you try to open the door leaving the orc's lair
              if storyline & |<sl_orc_is_dead
                message(string("Click! You unlock the door with the key you stole from the orc!"))
                map[p_x+p_y*map_w] := "/"
              else
                message(string("The door is locked. "))
            else
             case roll(1,50)
               1..10:
                 message(string("Umph! The door is stuck."))
               '11:
               '  message(string("You try to open the door, but it transforms into a Trollish Arch-Guardian!"))
               '  map[p_x+p_y*map_w] := "t"
               40..42:
                 message(string("You open the door, revealing a pit."))
                 map[p_x+p_y*map_w] := " "
               other:
                 message(string("You open the door. "))
                 map[p_x+p_y*map_w] := "/"
            p_x := op_x 'cancel move
            p_y := op_y
          " ": 'pit
            message(string("You fall into the open pit! "))
            p_hp := (p_hp - 5) #> 0'hurt the PC
          "_": 'altar
            message(string("You step onto the altar. "))           
          "0": 'pool
            message(string("You step into the pool. "))
          ">","<":
            message(string("A stairwell leads "))
            if map[p_x+p_y*map_w] == "<"
              message(string("up"))
            else
              message(string("down"))
            message(string("wards here. "))
          "\":
            arrows++
            message(string("You pick up the arrow. "))
            map[p_x+p_y*map_w] := "."
          "}":
            if storyline & |<sl_longbow
              message(string("But you already have one. "))
            else              
              message(string("You pick up the longbow. "))
              map[p_x+p_y*map_w] := "."
              storyline |= |<sl_longbow
          "!":
            potions++
            message(string("You pick up the potion. "))
            map[p_x+p_y*map_w] := "."
          "!":
            potions++
            message(string("You pick up the potion. "))
            map[p_x+p_y*map_w] := "."
          "?":
            scrolls++
            message(string("You pick up the scroll. "))
            map[p_x+p_y*map_w] := "."             
          ".": 'boring floor tile, do nothing!
                        
          'TODO: more item walk-onto events


          


          {*** PC ATTACKING MONSTER ***}
          "a".."z","A".."Z": 'monster
            mn := map[p_x+p_y*map_w] - "a" 'gets the species of the monster
            rid := get_monster_rid(p_x,p_y)'identifies instance of monster being attacked
            pc_attacks_monster(mn,rid)
            p_x := op_x 'cancel move
            p_y := op_y
                     
            

          other:
            message(string("A "))
            say_tile(p_x,p_y)
            message(string(" lies here. "))


            



          
      {*** MONSTER AI ***}
      rid := -1
      repeat 'for each active monster
        tmp := monster[++rid]
        if tmp.BYTE[2] == 0 'no ai for disabled monsters
          next
        mn := rid2monster_number(rid)
        
        if tmp.BYTE[3] == 0 'check for dying monsters (no hp left)
          {message(string("The "))
          say_monster_name(mn)
          message(string(" collapses. "))}
          {TODO: the following is a bit of a hack. The monster will not drop a corpse if there is an item on the tile
           it was standing on when it died. This is because there cannot be multiple items on a single tile. The monster
           standing on an item is already a sloppy swap-buffer (under_monster[] array). If I ever add item stacking this
           can be fixed. }
          if monster_table[3*mn+2] & |<m_eatable AND under_monster[rid] == "." 'roll for droping corpse if eatable
            map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := "%" | (mn*256) 'leave corpse on floor, properly identified
          else
            map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := under_monster[rid] 'no corpse, just restore old tile
          tmp.BYTE[2] := 0 'unset active flag (removes monster from memory)

        elseif not (tmp.BYTE[2] & |<mr_tapped)  'try to move

          dir_x := dir_y := 0
          get_free_dir(tmp.BYTE[0],tmp.BYTE[1]) 'enumerate directions which can be moved in
          
          if tmp.BYTE[2] & |<mr_tame 'if tame, walk aimlessly            
            i := roll(1,8)-2            'choose a random free direction
            if free_dir & |<i
              set_dir(i)                    ' sets dir_x/y globals
            if tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w == p_x+p_y*map_w 'dont hit PC
              dir_x := dir_y := 0
            
          elseif tmp.BYTE[2] & |<mr_afraid  'else-if afraid, move away from pc (or cower if blocked in)
            i := roll(1,8)-2
            repeat 9              'find a direction away from the PC       
              i := ++i // 8       '"
              set_dir(i)
              if free_dir & |<i AND (||(tmp.BYTE[0]+dir_x - p_x) + ||(tmp.BYTE[1]+dir_y - p_y)) > (||(tmp.BYTE[0] - p_x) + ||(tmp.BYTE[1] - p_y)) 
                quit                   
            if not (free_dir & |<i) OR i == 8             
              dir_x := dir_y := 10  'flag for prefering a neutral move       
            
          else 'else move towards pc (in any direction which would decrease distance-to-pc)
            i := roll(1,8)-2
            repeat 9              'find a direction towards the PC       
              i := ++i // 8       '"
              set_dir(i)
              if free_dir & |<i AND (||(tmp.BYTE[0]+dir_x - p_x) + ||(tmp.BYTE[1]+dir_y - p_y)) < (||(tmp.BYTE[0] - p_x) + ||(tmp.BYTE[1] - p_y)) 
                quit                   
            if not (free_dir & |<i) OR i == 8             
              dir_x := dir_y := 10
                   
          if dir_x == 10 'check for attempt neutral move flag
            dir_x := dir_y := 0
            i := roll(1,8)-2
            repeat 8              'find a direction towards the PC       
              i := ++i // 8       '"
              set_dir(i)
              if free_dir & |<i AND (||(tmp.BYTE[0]+dir_x - p_x) + ||(tmp.BYTE[1]+dir_y - p_y)) == (||(tmp.BYTE[0] - p_x) + ||(tmp.BYTE[1] - p_y)) 
                quit                   
            if not (free_dir & |<i)             
              dir_x := dir_y := 0

          if monster_table[3*mn+2] & |<m_archer
            repeat ii from 1 to 4
             if tmp.BYTE[0] + ii*dir_x == p_x AND tmp.BYTE[1] + ii*dir_y == p_y
               message(string("The "))
               say_monster_name(mn)
               message(string(" shoots an arrow. "))
               arrow_xs := dir_x
               arrow_ys := dir_y

                case arrow_xs + 10*arrow_ys
                  9:
                    tmp2 := "/"
                  10:
                    tmp2 := "|"
                  11:
                    tmp2 := "\"
                  -1:
                    tmp2 := "-"
                  1:
                    tmp2 := "-"
                  -11:
                    tmp2 := "\"
                  -10:
                    tmp2 := "|"
                  -9:
                    tmp2 := "/"

               repeat i from 1 to 7
                text.locate(map_x_offset+tmp.BYTE[0]+i*arrow_xs,map_y_offset+tmp.BYTE[1]+i*arrow_ys)
                text.out(tmp2)
                if i > 1
                  text.locate(map_x_offset+tmp.BYTE[0]+(i-1)*arrow_xs,map_y_offset+tmp.BYTE[1]+(i-1)*arrow_ys)'clean up old arrow icon
                  text.out(map[tmp.BYTE[0]+(i-1)*arrow_xs+(tmp.BYTE[1]+(i-1)*arrow_ys)*map_w])
                waitcnt(clkfreq/10 + cnt) 'wait 1/3 second
                case map[tmp.BYTE[0]+i*arrow_xs+(tmp.BYTE[1]+i*arrow_ys)*map_w]
                  "y":
                    message(string("The arrow hits the gollum and breaks. "))
                    quit
                  "a".."z","A".."Z":
                    mn2 := map[tmp.BYTE[0]+i*arrow_xs+(tmp.BYTE[1]+i*arrow_ys)*map_w] - "a" 'gets the species of the monster
                    rid2 := get_monster_rid(tmp.BYTE[0]+i*arrow_xs,tmp.BYTE[1]+i*arrow_ys)'identifies instance of monster being attacked
                    monster.BYTE[4*rid2+3] := 0
                    message(string("The "))
                    say_monster_name(string(" is killed instantly. "))
                    under_monster[rid2]:="\" 'note: this is ok even if the monster was slain, because the clean-up is done later
                    quit
                  "#":
                    message(string("The arrow breaks! "))
                    quit
                if tmp.BYTE[0]+i*arrow_xs+(tmp.BYTE[1]+i*arrow_ys)*map_w == p_x + p_y*map_w
                  if roll(1,2) == 1
                   message(string("You dodge the arrow! "))
                  else
                   message(string("You are hit! "))
                   p_hp -= roll(1,6)
                   if get_monster_level(mn) > 10
                    p_hp -= roll(1,5) 'more damage ahahaha!
                   quit
                if i==7
                 map[tmp.BYTE[0]+i*arrow_xs+(tmp.BYTE[1]+i*arrow_ys)*map_w]:="\"

               text.locate(map_x_offset+tmp.BYTE[0]+i*arrow_xs,map_y_offset+tmp.BYTE[1]+i*arrow_ys)'redraw tile under arrow's last position
               text.out(map[tmp.BYTE[0]+i*arrow_xs+(tmp.BYTE[1]+i*arrow_ys)*map_w])
               if roll(1,2) == 1
                 dir_y := dir_x := 0 'cancel the archer's move
               else
                i := roll(1,8)-2            'choose a random free direction
                if free_dir & |<i
                 set_dir(i)                    ' sets dir_x/y globals
                if tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w == p_x+p_y*map_w 'dont hit PC
                 dir_x := dir_y := 0



          if tmp.BYTE[0] + dir_x == p_x AND tmp.BYTE[1] + dir_y == p_y  'if move would place monster on top of pc, the monster is attacking
            dir_x := dir_y := 0  'don't let monster move on top of PC            
            message(string("The "))
            say_monster_name(mn)
            if roll(1,7) => 3 'roll for hit (based on monster level and modifiers)                                            
              damage := roll(1,get_monster_level(mn)+1) 'base damage
              if roll(1,18) == 1 'roll for critical hit
                damage += get_monster_level(mn) + 1
                message(string(" musters all its strength and"))
              if roll(1,3) == 1 AND monster_table[3*mn+2] & |<m_claws
                message(string(" stabs through your armor and"))
              else
                damage := (damage - p_level/3 - 1) #> 0 'apply PV (armour)           
              if damage == 0
                message(string(" fails to hurt you. ")) 
              else
                message(string(" hits you. "))
                p_hp -= damage
                if roll(1,50) == 1 OR (roll(1,20) AND monster_table[3*mn+2] & |<m_angry) 'roll for drawing blood (much increased by m_angry)
                  p_state |= |<bleeding                  
            else
              message(string(" misses you. "))              

          if map[tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w] == " " AND get_monster_level(mn) > 13
            i := roll(1,8)-2
            repeat 9              'find a direction away from the PC
              i := ++i // 8       '"
              set_dir(i)
              if free_dir & |<i AND map[tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w] <> " "
               quit
            if not (free_dir & |<i) OR i == 8
              dir_x := dir_y := 0
            else
              message(string("The "))
              say_monster_name(mn)
              message(string(" avoids the pit. "))

          'move monster data and restore old tile
          if dir_x <> 0 OR dir_y <> 0  'if it moved at all
                                                                                                        'trinodal tile shuffle
            tmp_swap := map[tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w]                                't = n
            map[tmp.BYTE[0]+dir_x+(tmp.BYTE[1]+dir_y)*map_w] := map[tmp.BYTE[0]+tmp.BYTE[1]*map_w]      'n = m                  'm -> n
            map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := tmp_swap                                              'm = t
            tmp_swap := under_monster[rid]                                                              't = u
            under_monster[rid] := map[tmp.BYTE[0]+tmp.BYTE[1]*map_w]                                    'u = m                  'n -> u
            map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := tmp_swap                                              'm = t                  'u -> m
            'if tmp_swap.BYTE[0] <> "."
              'message(string("The "))
              'say_monster_name(mn)
              'message(string(" displaces the "))
              'say_tile(tmp.BYTE[0],tmp.BYTE[1])    'item only (can't displace other monsters)
              'message(string(". "))            
            tmp.BYTE[0] += dir_x 'move monster
            tmp.BYTE[1] += dir_y

          case under_monster[rid]
           " ":
             message(string("The "))
             say_monster_name(mn)
             message(string(" falls into the abyss! "))
             tmp.BYTE[2] := 0 'unset active flag (removes monster from memory)
             map[tmp.BYTE[0]+tmp.BYTE[1]*map_w] := under_monster[rid]
           "0":
            message(string("The "))
            say_monster_name(mn)
            message(string(" looks stronger. "))
            tmp.BYTE[3]++
                
        monster[rid] := tmp
      until rid == max_monsters - 1





       {*** APPLY EFFECTS ***}
      'take care of static effects due to items underfoot which persist
      case map[p_x+p_y*map_w]
        "_":
          if (p_mp < p_mp_max)
            p_mp++
            message(string("You feel pious! "))
        "0":
          if (p_hp < p_hp_max)
            p_hp++
            message(string("You feel refreshed! "))
            
      if p_state & |<poisoned
        tmp := roll(2,6) - 5      'roll for poison damage (or cure)
        if tmp == -3              
          p_state &= !(|<poisoned)'cure poison
        if tmp > 0
          message(string("The poison runs through your veins. "))
          p_hp := (p_hp - tmp) #> 0

      if p_state & |<paralyzed
        if roll(1,8) == 1
          p_state &= !(|<paralyzed)
          message(string("You can move again! "))          


      {LEVEL UP!}
      if p_xp/50 > p_level 'TODO make this logarithmic
        p_level++
        p_hp_max += p_level*2
        p_hp += p_level*2
        p_mp += p_level
        p_mp_max += p_level
        message(string("Your muscles feel stronger. "))

          
      {*** REDRAW SCREEN (as needed) ***}
      'text.out(ClrScr)
      redraw_visable

      'draw charicter
      text.locate(p_x+map_x_offset,p_y+map_y_offset)
      text.out("@")

      'update stats indicator
      text.locate(1,rows - 4)
      text.str(string("HP "))
      text.dec(p_hp)
      text.str(string("("))
      text.dec(p_hp_max)
      text.str(string(")  MP "))
      text.dec(p_mp)
      text.str(string("("))
      text.dec(p_mp_max)
      text.str(string(")  XP "))
      text.dec(p_level)
      text.out("/")
      text.dec(p_xp)
      if storyline & |<sl_longbow
        text.str(string("  LONGBOW"))
      if arrows > 0        
        text.str(string("  ARROWS "))
        text.dec(arrows)
      if potions > 0        
        text.str(string("  POTIONS "))
        text.dec(potions)
      if scrolls > 0        
        text.str(string("  SCROLLS "))
        text.dec(scrolls)        
      repeat 5
        text.out(" ")
      text.locate(20,rows - 2)
      case level
        0:
          text.str(string("             WILDERNESS"))
        1..5:
          text.str(string("           EARTHY CAVES "))
          text.dec(level)
        6..10:
          text.str(string("           DARK DUNGEONS "))
          text.dec(level-5)
        11..15:
          text.str(string("    DOMAIN OF THE FALLEN ELF "))
          text.dec(level-10)
      'output state of various player modifiers   
      'text.locate(1,rows - 2) 
      'repeat cols - 2 'clear line
      '  text.out(" ")
      'text.out(MoveX)
      '  text.out(1)
      'TODO the rest of them
      
      

      {*** LOOSING THE GAME ***}
      if p_luck == 0 AND roll(1,256*8) == 1 'chance of insta-death when doomed                          
        message(string("A previously unseen loose block in the cieling dislodges and falls square on your head. "))
        p_hp := 0 'kill the PC
      if p_hp =< 0
        message(string("You die..."))

        waitcnt(clkfreq + cnt) 'wait one second for the death to sink in....     
        text.locate(titleblock_x+4,15)
        text.str(string(" * -  PRESS ANY KEY TO CONTINUE  - * "))
        text.locate(titleblock_x+4,14)
        text.out(" ")
        repeat 35
          text.out("*")
        text.out(" ")
        text.locate(titleblock_x+4,16)
        text.out(" ")
        repeat 35
          text.out("*")
       text.locate(titleblock_x+4,17)
        repeat 37
          text.out(" ")
       text.locate(titleblock_x+4,13)
        repeat 37
          text.out(" ")
        text.out(" ")
        kb.getkey
        
        level-- 'go back to begining of level
        p_hp := p_hp_max
        p_mp := p_mp_max         
        potions := save_potions      'restore items (so you can't farm)
        arrows := save_arrows
        scrolls := save_scrolls
        storyline := save_storyline
        quit
        
    level++


PUB pc_attacks_monster(mn,rid) | damage, tmp

  message(string("You "))
  damage := roll(2,6+p_level)
  if monster.BYTE[4*rid+2] & |<mr_tame     'check if this is a backstab (backstabs allways hit!)
    monster.BYTE[4*rid+2] &= !(|<mr_tame)
    p_luck := (p_luck - 5) #> 0 'it's bad luck to backstab!
    message(string("backstab "))              
  elseif (roll(1,10) =< 7)   'TODO: roll for hit (based on weapon and monster)
    if damage == 0 'TODO: roll for damage TODO: subtract monster PV
       message(string("fail to damage "))
    else
       message(string("hit "))
  else
    message(string("miss "))
    damage := 0
  monster.BYTE[4*rid+3] := (monster.BYTE[4*rid+3] - damage) #> 0 'apply damage to monster
  message(string("the "))
  if monster.BYTE[4*rid+2] & |<mr_afraid
    message(string("terrified "))
  say_monster_name(mn)           
  if monster.BYTE[4*rid+3] == 0 'if monster's health was reduced to zero gain experience
    if mn == "u" - "a"
      message(string(", mortally wounding him. <<Noooooooooooooooooo>>. The dark-elf is dead. YOU HAVE WON!"))
      repeat 30
        waitcnt(clkfreq/10 + cnt)
        message(string("!"))
      message(string(" "))
      storyline |= |<sl_dark_elf_fallen
      message(string("You hear footsteps from below. "))
      map[57+15*map_w] := ">"
      return
    else
      message(string(", slaying it. "))
    if level == lev_orc AND (storyline & |<sl_orc_is_dead == 0)
      message(string("You found a key! "))
      storyline |= |<sl_orc_is_dead
      p_xp += roll(10,3)
      map[33+15*map_w]:="+"
      map[27+15*map_w]:="+"
    tmp := get_monster_level(mn)
    p_xp += roll(2,2)
    if (tmp > level)
      p_xp += roll(5,2) 'give bonus for slaying out of depth monster
      message(string("You feel more experienced. "))
  elseif not (monster_table[3*mn + 2] & |<m_angry) AND roll(1,12) == 1 'roll for monster becoming afraid (if not m_angry)
      monster.BYTE[4*rid+2] |= |<mr_afraid
      message(string(", frightening it. "))
  else        'no post-attack effect
      message(string(". "))            


PUB roll(number_of_dice, number_of_sides) : retval
  retval := 0
  repeat number_of_dice
    retval += ||(dice?//number_of_sides) + 1

PUB say_monster_name(monster_number) | b1, b2, i, save_col, save_row
  b1 := monster_table[3*monster_number    ]    'get the two longs holding the monster name
  b2 := monster_table[3*monster_number + 1]

  save_col := text.get_col
  save_row := text.get_row
  text.locate(message_col, message_row)

  i:=0
  repeat 4
    if b1.BYTE[i] == " "
      quit
    text.out(b1.BYTE[i++])
  i:=0
  repeat 4
    if b2.BYTE[i] == " "
      quit
    text.out(b2.BYTE[i++])
  
  message_col := text.get_col
  message_row := text.get_row
  text.locate(save_col, save_row)


PUB get_monster_level(monster_number) : m_level
  m_level := monster_table[3*monster_number + 2] & $F 'extract low nibble from "monster details" long

PUB get_monster_rid(x_pos,y_pos) : rid | tmp
  rid := 0
  repeat 32
    tmp := monster[rid]   
    if tmp.BYTE[0] == x_pos AND tmp.BYTE[1] == y_pos AND tmp.BYTE[2] <> 0
      return rid
    rid++
  return -1

PUB rid2monster_number(rid) : mn
  mn := monster[rid]                 'grab x,y
  mn := map[mn.BYTE[0] + map_w * mn.BYTE[1]] 'grab map tile
  mn := mn.BYTE[0] - $61 'convert to monster number from tile (todo: check for uppercase monsters)

PUB first_free_rid  : rid  | tmp
  rid := 0
  repeat 32
    if (monster[rid] & $00FF0000) == 0
      return rid
    rid++
  message(string("FATAL ERROR: too many active monsters. "))    
  return -1

PUB get_free_dir(x_pos,y_pos) | i, j
  free_dir := 0
  i := 0
  repeat
   case i
    0:
      j := (x_pos - 1) + (y_pos - 1)*map_w
    1:
      j := (x_pos + 0) + (y_pos - 1)*map_w
    2:
      j := (x_pos + 1) + (y_pos - 1)*map_w
    3:
      j := (x_pos - 1) + (y_pos + 0)*map_w
    4:
      j := (x_pos + 1) + (y_pos + 0)*map_w
    5:
      j := (x_pos - 1) + (y_pos + 1)*map_w
    6:
      j := (x_pos + 0) + (y_pos + 1)*map_w
    7:
      j := (x_pos + 1) + (y_pos + 1)*map_w

   case map[j]
     "#","a".."z","A".."Z","+":
       free_dir |= |<i
       
  until ++i == 8
   
  !free_dir

PUB set_dir(i)
  dir_x := dir_y := 0
  case i
    0:
      dir_x--
      dir_y--
    1:
      dir_y--
    2:
      dir_x++
      dir_y--
    3:
      dir_x--
    4:
      dir_x++
    5:
      dir_x--
      dir_y++
    6:
      dir_y++
    7,8:
      dir_x++
      dir_y++

PUB say_dir(i) | ptr 'delme
  case i
    0:
      message(string("up-left")) 
    1:
      message(string("up"))   
    2:
      message(string("up-right"))   
    3:
      message(string("left"))   
    4:
      message(string("right"))   
    5:
      message(string("down-left"))   
    6:
      message(string("down"))   
    7:
      message(string("down-right"))   

PUB say_tile(x_pos,y_pos) | tile, save_col, save_row
  tile := map[x_pos + y_pos*map_w]
  case tile.BYTE[0]
    "a".."z","A".."Z": 'monster
      say_monster_name(tile.BYTE[0] - $61)
      save_col := text.get_col
      save_row := text.get_row
      text.locate(message_col, message_row)
      text.str(string(" (level "))
      text.dec(get_monster_level(tile.BYTE[0] - $61))
      text.str(string(", hp "))
      text.dec(monster.BYTE[4*get_monster_rid(x_pos,y_pos)+3])
      text.str(string(")"))
      tile := monster[get_monster_rid(x_pos,y_pos)]
      if tile.BYTE[2] & |<mr_tame
        text.str(string(" {tame}"))
      if tile.BYTE[2] & |<mr_afraid
        text.str(string(" {afraid}"))
      message_col := text.get_col
      message_row := text.get_row
      text.locate(save_col, save_row)           
    "!":
      message(string("potion"))   'todo: add suffixes for various modifiers
    "0":
      message(string("pool"))     ' ditto et al
    "?":
      message(string("scroll"))
    "_":
      message(string("altar"))
    "$":
      message(string("gold"))
    "+":
      message(string("closed door"))
    "/":
      message(string("open door"))
    "}":
      message(string("longbow"))
    "\":
      message(string("arrow"))
    "%":
      say_monster_name(tile.BYTE[1])
      message(string(" corpse"))
    other:
      message(string("unidentified object"))

PUB message(stringptr) | save_col, save_row 'display a message in the message buffer
  save_col := text.get_col
  save_row := text.get_row
  text.locate(message_col, message_row)
  text.str(stringptr)
  message_col := text.get_col
  message_row := text.get_row
  text.locate(save_col, save_row)

PUB message_dec(num)| save_col, save_row
  save_col := text.get_col
  save_row := text.get_row
  text.locate(message_col, message_row)
  text.dec(num)
  message_col := text.get_col
  message_row := text.get_row
  text.locate(save_col, save_row)

PUB darken_line(line) | i
  {{When the torch-light leaves a tile we darken it,
     unless it is a wall tile, in which case it stays
     to show the outline of the level visited so far.}}
  i := -1
  text.locate(map_x_offset+p_x - p_vision - 1,map_y_offset+p_y - p_vision + line) 'erase old top line
  repeat 
    if map[p_x - p_vision + i + map_w*(p_y - p_vision + line)] == "#"
      text.out(Seek)
    else
      text.out(" ")
  until ++i == p_vision * 2 + 3

PUB redraw_visable | i, tmp, rid, xp, yp, tmp_, ml, mn

      'draw visable area
      tmp1 := 0
      darken_line(-1)
      repeat
        darken_line(tmp1)

        text.locate(map_x_offset+p_x - p_vision,map_y_offset+p_y - p_vision + tmp1)
        tmp2 := 0
        xp := p_x - p_vision + tmp2
        yp := p_y - p_vision + tmp1
        repeat
          xp := p_x - p_vision + tmp2
          yp := p_y - p_vision + tmp1
          i := (yp)*map_w + xp
          if yp < map_h AND yp => 0 AND xp < map_w AND xp => 0 AND visible(xp-p_x,yp-p_y) 'test for visibility
            tmp := map[i]
            if level==0 AND tmp == "#"
              text.out("T") 'walls render as trees in wilderness
            else
              text.out(map[i])
            case tmp.BYTE                      'monsters activate when you see them... (todo make them activate at a more appropriate time?)
              "a".."z","A".."Z":
                rid := get_monster_rid(xp,yp)
                if rid == -1 'check for a new monster
                  rid := first_free_rid
                  mn := tmp.BYTE ' (For some reason mn := tmp.BYTE - $61 does
                  mn := mn - $61 '   not compile under bstc atm.)
                  ml := get_monster_level(mn)
                  under_monster[rid] := "." 'monsters spawn above normal tiles
                  tmp_.BYTE[0] := xp & $FF
                  tmp_.BYTE[1] := yp & $FF
                  tmp_.BYTE[2] := 1  'set active flag (todo: do other stuff)
                  tmp_.BYTE[3] := roll(ml+1,3) + ml 'set monster initial HP
                  if monster_table[3*mn + 2] & |<m_friendly OR roll(1,6) == 1 'some creatures spawn tame
                    tmp_.BYTE[2] |= |<mr_tame
                  monster[rid] := tmp_
                  if tmp.BYTE == "u" 'the dark elf
                    message(string("The Fallen Elf says: <<You shall perish at the tips of my firey arrows!>> "))
              ">":
                message(string("You can see the staircase. "))
          else
            text.out(Seek)  'placeholder (don't display anything)
        until tmp2++ == p_vision*2 + 1
      until tmp1++ == p_vision*2 + 1
      darken_line(tmp1)

      'all you touch and all you see are all your life will ever be

PUB visible(x,y) | f,s

  {{Returns TRUE iff the specified position is visible from the pc's location}}

  f := 0 'initialize flags

  'reduce the problem to octets
  if x < 0
    x := -x
    f |= |<vis_xn
  if y < 0
    y := -y
    f |= |<vis_yn
  if y > x
    f |= |<vis_sw
    s := y
    y := x
    x := s

  'lookup critical tiles
  if vis_helper(1,0,f)
    f |= |<vis_01
  if vis_helper(2,0,f)
    f |= |<vis_02
  if vis_helper(3,0,f)
    f |= |<vis_03
  if vis_helper(1,1,f)
    f |= |<vis_11
  if vis_helper(2,1,f)
    f |= |<vis_12
  if vis_helper(3,1,f)
    f |= |<vis_13
  if vis_helper(2,2,f)
    f |= |<vis_22

  'solve the problem in the first octet
  if y==0
    if x==1
      return TRUE
    elseif x==2
      return f & |<vis_01
    elseif x==3
      return f & |<vis_01 AND f & |<vis_02 'both 01 and 02 must be unblocked
    elseif x==4
      return f&|<vis_01 AND f&|<vis_02 AND f&|<vis_03
  elseif y==1
    if x==1
      return TRUE
    elseif x==2
      return f & |<vis_01 OR f & |<vis_11 'either 01 or 11 must be unblocked
    elseif x==3
      return f & |<vis_01 AND f & |<vis_12
    elseif x==4
      return f & |<vis_01 AND (f & |<vis_02 OR f & |<vis_12) AND f & |<vis_13
  elseif y==2
    if x==2
      return f & |<vis_11
    elseif x==3
      return f & |<vis_11 AND f & |<vis_12
    elseif x==4
      return f & |<vis_11 AND f & |<vis_12 AND f & |<vis_13
  elseif y==3
    if x==3
      return f & |<vis_11 AND f & |<vis_22

  return FALSE

PUB vis_helper(x,y,f) | s
  {{returns TRUE iff the specified cell is transparent}}

  if f & |<vis_sw
    s := y
    y := x
    x := s

  if f & |<vis_xn
    x := -x
  if f & |<vis_yn
    y := -y

  case map[p_x + x + (p_y + y)*map_w]
    "#","+":
      return FALSE
    other:
      return TRUE 


PUB redraw_map | i

  'text.out(0) 'clear screen (doesnt work????)
  text.out(Home)
  i := 0
  repeat map_h
    text.locate(map_x_offset,map_y_offset+i/map_w)
    repeat map_w
      text.out(map[i++])

PUB randomize_map | x, y, t1, t2, sx, sy, rx, ry, tmp, tmp_
{{GENERATE A RANDOM DUNGEON LEVEL:
 the key concept of Progue levels is that initially they consist of nothing but ASCII
 that is, there is no binary component to them. As the level is played through binary
 components are created and stored in the second byte of each tile word, and elsewhere.
}}

  'todo: make player's name help seed dungeon

  'choose appropriate colors:
  case level
    0:
      text.set_colors(0,3,0,0,1,0) 'green on dark green  -  The Wilderness
    1..5:
      text.set_colors(2,1,0,0,0,0) 'brown on black        -  Earthy Caves
    6..10:
      text.set_colors(2,2,2,0,0,0) 'grey on black        -  Dark Dungeon
    11..15:
      text.set_colors(3,0,0,0,0,0) 'red on black         -  The Domain of the Fallen Elf
    other:
      text.set_colors(3,3,3,0,0,0)

  text.out(ClrScr)

  text.locate(titleblock_x,titleblock_y)
  repeat 50
    text.out("*")
  text.locate(titleblock_x,titleblock_y+1)
  text.str(string("*               LEVEL  "))
  text.dec(level)
  text.str(string("                         *"))
  text.locate(titleblock_x,titleblock_y+2)
  repeat 50
    text.out("*")

  text.locate(titleblock_x,titleblock_y+4)
  case level
    0:
      text.str(string("You awake one day in the Wilderness..."))
    1:
      text.str(string("You begin to explore the Earthy Cave."))
    2..4:
      text.str(string("Passing deeper into the Earthy Cave..."))
    lev_orc:
      text.str(string("A sign reads: <<BEWARE OF ORC>>."))
    6:
      text.str(string("Now entering the Dark Dungeon."))
    7..9:
      text.str(string("Passing deeper into the Dark Dungeon."))
    10:
      text.str(string("You hear the scraping of bone-on-bone."))
    11:
      text.str(string("You have entered the Domain of the Fallen Elf."))
      text.locate(titleblock_x,titleblock_y+5)
      text.str(string("The fire burns your feet. "))
      text.str(string("Only dead men have ever come this far."))
    12..14:
      text.str(string("Ever closer to the Fallen Elf himself..."))
    15:
      text.str(string("You hear arcane mumbling: a spell-caster at work."))
      text.locate(titleblock_x,titleblock_y+5)
      text.str(string("The Fallen Elf awaits you."))
    16:
      text.str(string("Where do you think you're going? You already beat the game! "))
    other:
      text.str(string("Get a life already. "))


      
  dice := level'this ensures that level generation is deterministic

  'initialize map to all stone
  x := -1
  y := -1
  repeat x from 0 to map_w-1
    repeat y from 0 to map_h-1
      map[ x + y*map_w] := "#"

  'there are some special levels: 0,5,10,15
  case level
    0:
      p_x := 12
      p_y := 15
      repeat x from 1 to map_w-2
        repeat y from 1 to map_h-2
          map[ x + y*map_w] := "."
      repeat 12
        map[roll(1,map_w-6)+3+(roll(1,map_w-6)+3)*map_w]:="f"
        map[roll(1,map_w-6)+3+(roll(1,map_w-6)+3)*map_w]:="r"
        map[roll(1,map_w-6)+3+(roll(1,map_w-6)+3)*map_w]:="0"
      repeat 300
        map[roll(1,map_w-6)+3+(roll(1,map_w-6)+3)*map_w]:="#"
  '    map[p_x + p_y*map_w] := "."
      repeat x from p_x-2 to p_x+2
        repeat y from p_y-2 to p_y+2
          map[x+y*map_w]:="."
      map[roll(1,map_w/2)+28+(roll(1,map_w-6)+3)*map_w]:=">"

      return
      
    lev_orc: 'orc level
      p_x := 30
      p_y := 21
      repeat x from 29 to 31            'create start and stair rooms
        repeat y from 8 to 10
          map[ x + y*map_w] := "."
          map[ x + (y+12)*map_w] := "." 
      map[30+9*map_w]:=">"
      repeat x from 28 to 32
        repeat y from 12 to 18
          map[ x + y*map_w] := "."
      repeat y from 0 to 2
        map[29 + (13+2*y)*map_w]:="#"
        map[31 + (13+2*y)*map_w]:="#"
      map[30 + 19*map_w]:="."
      map[30 + 11*map_w]:="+" 
      'secret rooms:
      if roll(1,2)==1
        t2 := 1
      else
        t2 := -1
      repeat x from 4 to 8
        repeat y from 13 to 17
          case roll(1,4)
           1:
            t1 := "?"
           2:
            t1 := "!"
           3:
            t1 := "\"
           4:
            t1 := "?"
          map[30+x*t2+y*map_w]:=t1
          map[30-x*t2+y*map_w]:="c"
      map[30 + (15)*map_w]:="o"
      return
      
    10:
      'army of the dead
      p_x := 1
      p_y := 15
      repeat x from 8 to 50
        repeat y from 10 to 20
          case roll(1,101)
           2..5:
            t1 := "0"
           7..10:
            t1 := "_"
           11..32:
            t1 := " "
           40..60:
            t1 := "#"
           75..90:
            if x < 12
             t1 := "."
            else
             t1 := "x"
           other:
             t1 := "."
          map[x+y*map_w]:=t1
      repeat x from 1 to 10
        map[x+15*map_w] := "."
      repeat x from 48 to 58
        map[x+15*map_w] := "."
      repeat x from 56 to 58
        repeat y from 14 to 16
          map[x+y*map_w]:="."
      map[57+15*map_w]:=">"
      return
      
    15:
      'the Lair of the Fallen Elf
      p_x := 30
      p_y := 15
      repeat x from 8 to 50
        repeat y from 5 to 25
          case roll(1,329)
           1:
            t1 := "0"
           2:
            t1 := "_"
           3..4:
            t1 := " "
           5..8:
            t1 := "#"
           9:
            t1 := "."
           10:
            if x < 25
             t1 := "x"
            elseif x < 35
             t1 := "t"
            else
             t1 := "."
           other:
             t1 := "."
          map[x+y*map_w]:=t1
      'repeat x from 1 to 10
      '  map[x+15*map_w] := "."
      repeat x from 48 to 58
        map[x+15*map_w] := "."
      repeat x from 56 to 58
        repeat y from 14 to 16
          map[x+y*map_w]:="."
      repeat x from p_x-2 to p_x+2
        repeat y from p_y-2 to p_y+2
          map[x+y*map_w]:="."
      map[57+15*map_w]:="u"
      return            

  'create start room
  p_x := roll(1,map_w-8)+4
  p_y := roll(1,map_h-8)+4  
    repeat x from p_x-1 to p_x+1
      repeat y from p_y-1 to p_y+1
        map[x+y*map_w]:="."
        
  x:=p_x
  y:=p_y
  'random walk from start
  repeat roll(2,8)+2
    case roll(1,2) 'choose random direction
      1: 'left
        repeat roll(1,x)-1
          map[--x + y*map_w] := "."
      2: 'right
        repeat roll(1,map_w-x-1)-1
          map[++x + y*map_w] := "."
    case roll(1,2) 'choose another random direction
      1: 'up
        repeat roll(1,y)-1
          map[x + --y*map_w] := "."
      2: 'down
        repeat roll(1,map_h-y-1)-1
          map[x + ++y*map_w] := "."
  sx := x  'save stair location to allow for room addition
  sy := y

  'randomly add rooms
  repeat roll(1,8)
    t1 := roll(3,4) 'room width
    t2 := roll(3,3) 'room height
    rx := roll(1,map_w-t1-2)
    ry := roll(1,map_h-t2-2)
    repeat x from rx to rx+t1
      repeat y from ry to ry+t2
        if x == rx AND map[x-1+y*map_w]=="." AND map[x-1+(y+1)*map_w]=="#" AND map[x-1+(y-1)*map_w]=="#"
          map[x-1+y*map_w]:="+"
        if x == rx+t1 AND map[x+1+y*map_w]=="." AND map[x+1+(y+1)*map_w]=="#" AND map[x+1+(y-1)*map_w]=="#"
          map[x+1+y*map_w]:="+"
        if y == ry AND map[x+(y-1)*map_w]=="." AND map[x+1+(y-1)*map_w]=="#" AND map[x-1+(y-1)*map_w]=="#"
          map[x+(y-1)*map_w]:="+"
        if y == ry+t2 AND map[x+(y+1)*map_w]=="." AND map[x+1+(y+1)*map_w]=="#" AND map[x-1+(y+1)*map_w]=="#"
          map[x+(y+1)*map_w]:="+"
        case roll(1,1000)-1
          '00..04:
          '  tmp := "$" 'coins
          10..13:
            tmp := "!" 'potion
          20..24:
            tmp := "0" 'pool
          25..27:
            tmp := "_" 'altar
          28..29:
            tmp := "?" 'scroll
          40:
            tmp := "}" 'bow
          41..48:
            tmp := "\" 'arrow
          50..60:
            tmp := " " 'open pit
          100..150:
            tmp := "#" 'wall
          500..530: 'monster!
            repeat
              tmp := roll(1,26)-1    'choose a random monster
              tmp_ := monster_table[3*tmp + 2]
            until (tmp_ & $FF) =< level AND (tmp_ & $FF) > level-5 'only spawn appropriate monsters
            tmp += $61 'convert to lowercase letters

          other:
            tmp := "." 'floor
        map[x+y*map_w] := tmp

  'build the stair room
  repeat x from sx-1 to sx+1
      repeat y from sy-1 to sy+1
        map[x+y*map_w]:="."
  map[sx+sy*map_w] := ">"

  'reconstruct outer wall:
  repeat x from 0 to map_w-1
    map[x+0*map_w]:="#"
    map[x+(map_h-1)*map_w]:="#"    
  repeat y from 0 to map_h-1
    map[0+y*map_w]:="#"
    map[map_w-1+y*map_w]:="#"
    


PUB charmap | asc
  text.out(Home)                                        
  text.str(string("CHARMAP ",7))
    
  asc := 1
  repeat
    text.locate(0+8*(asc/rows),asc//rows)    
    text.hex(asc,2)

    text.locate(4+8*(asc/rows),asc//rows)    
    text.out(asc)
  until asc++ == 255

  'kb.newkey 'wait for keystroke


DAT

{{Item Tables}}
'potion item details contains the potion id number
potion_table byte
'     name               id   effect
byte "magic",0          '0 +mp
byte "healing",0        '1 +hp
byte "invisibility",0   '2 non-undead monsters cannot follow you
byte "beer",0           '3 +hp
byte "poison",0         '4 set poisoned
byte "wisdom",0         '5 +xp
byte "troll blood",0    '6 set angry
byte "water",0          '7
byte "mana",0           '8 +mp_max
byte "strength",0       '9 +hp_max

{weapon_table byte
'weapon details contain 4bit weapon id and four bit modifier flags
'the higher the weapon id, the more "high-level" it is.
'0-3  deal ~2 dmg
'4-7  deal ~4 dmg
'8-11 deal ~10 dmg
'12-15 are epic weapons ~15 dmg plus some special effect
'note: +hit normal is 5. 10 is perfect. over 10 means a shield cannot be warn (then subtract 10 to get actual +hit rating) 
     'name                XdY damage  
byte "dagger",0,          5,     1,4 'basic weapon level 
byte "whip",0,            4,     2,2
byte "brass knuckles",0,  19,    1,1
byte "light hammer",0,    3,     2,4

byte "short sword",0,     5,     1,8 'intermediate level        
byte "battle axe",0,      3,     2,5
byte "quarterstaff",0,    17,    1,10

byte "troll club",0,      2,     5,8 'advanced level
byte "long sword",0,      5,     2,10         
byte "warhammer",0,       3,     4,8
byte "great flail",0,     8,     8,2

byte "Sword of a Thousand Truths",0, 5, 2,10 'any damage done heals PC that amount   'todo rewatch south park season 10 episode 1
byte "Staff of the Magi",0,17,   1,15        '3*mp_max
byte "Reaper's Sythe",0,  15,    5,8         'causes instadeath to all non-undead, unnamed monsters hit
byte "Hammer of God",0,   14,    8,8         'instadeath to all undead hit

armor_table byte
'armor details contain 4bit armor id and four bit modifier flags.
' The first item in each group (bits 0 and 1 are zero) is a shield.

'higher armour id the more "high-level" it is.
'0-3  provide little effect
'4-7  provide ~4 total effect
'8-11 provide ~8 total effect 
'12-15 are epic armor and have some special effect
'note: 5 DV means +0, higher is + lower is -. PV is as written.
     'name              'DV     '+PV    '+to_hit (less than 5 means misses more often)
byte "wooden",0,        7,      0,      5
byte "robe",0,          6,      1,      5
byte "light furs",0,    3,      3,      3
byte "leather armor",0, 4,      2,      5

byte "medium",0,        9,      0,      4  
byte "dark cloak",0,    7,      1,      5
byte "thick furs",0,    4,      5,      4
byte "light mail",0,    5,      3,      5 

byte "tower",0,         13,     0,      3
byte "elven cloak",0,   9,      2,      5
byte "cave bear skin",0,4,      8,      4   
byte "chain mail",0,    6,      7,      5

byte "Electromagnetic",0, 20,   0,      3         'very good sheild! (75% chance to block magic attacks)
byte "Daemon's Garb",0,   7,    2,      5         'wearer is invisible to non-undead creatures
byte "Fish Scales",0,     5,     5,      5        'wearer can breath under water
byte "Mithril Chain Mail",0,    8,     9,      5  'unbreakable, does not rust
                 }

{{Spell Table}}
'TODO spell_table byte

{{Message Table}}
'TODO: place repeated messages here to save on memory

{{Monster Table}}
''format is three longs per letter of the alphabet: monster name (8 bytes), property long
monster_table long
byte "ant     ", long 1  | |<m_claws | |<m_fast
byte "bat     ", long 1 | |<m_flying | |<m_common
byte "cokroach", long 4 | |<m_claws
byte "wolf    ", long 6 | |<m_eatable | |<m_common | |<m_angry | |<m_claws | |<m_dodge
byte "dark-eye", long 7 | |<m_confusing | |<m_weak | |<m_rare
byte "cat     ", long 0 | |<m_eatable | |<m_weak | |<m_dodge | |<m_claws
byte "goblin  ", long 5 | |<m_archer | |<m_armor | |<m_speak | |<m_dodge
byte "halfling", long 13 | |<weak | |<m_armor | |<m_weapon | |<m_eatable | |<m_speak
byte "imp     ", long 10 | |<m_fire | |<m_undead | |<m_flying
byte "joker   ", long 12 | |<m_weak | |<m_friendly | |<m_rare | |<m_speak | |<m_swap
byte "kobold  ", long 7 | |<m_archer 'special: make poisonous meat
byte "lizard  ", long 2 | |<m_common
byte "minataur", long 11 | |<m_rare | |<m_eatable
byte "ice-newt", long 4 | |<m_rare | |<m_ice
byte "orc     ", long 9 | |<m_common | |<m_armor | |<m_weapon | |<m_eatable | |<m_dodge
byte "pixie   ", long 3 | |<rare | |<m_common | |<m_swap 'special: drops ALOT of money -- VERY RARE
byte "mage    ", long 9 | |<m_speak | |<m_fire | |<m_ice | |<m_weak
byte "rat     ", long 0 | |<m_common
byte "serpent ", long 9 | |<m_poison
byte "troll   ", long 14 | |<m_weapon | |<m_angry | |<m_eatable | |<m_strong | |<m_speak
byte "dark-elf", long 30 | |<m_angry | |<m_rare | |<m_ice | |<m_archer | |<m_speak | |<m_fast | |<m_dodge
byte "raptor  ", long 15 | |<m_common | |<m_fast | |<m_eatable | |<m_claws | |<m_angry | |<m_dodge
byte "worm    ", long 4 | |<m_breeder
byte "skeleton", long 9 | |<m_common | |<m_undead
byte "gollum  ", long 14 | |<m_confusing | |<m_stone_thrower | |<m_strong | |<m_undead | |<m_rare 
byte "zombie  ", long 13 | |<m_undead | |<m_weak | |<m_common
'TODO: uppercase letters? named monsters?





{{NOTES}}

{{on storing map files for special levels (non-random) or for saving a game:

a special level would consume 60*30 bytes of space (modifiers not needed) = 1.8k

saving an arbitrary level would consume 60*30*2 = 3.6k

however, if saving a particular dungeon level just the delta from the initial version
 could be recorded, thus greatly reducing the space required to at most 256 bytes.
  ( 64 dynamic tiles with X, Y, SYMBOL, and MODIFIERS fields)

}}               
